using Godot;
using System;

public class BuildModeUI : Control
{
    [Signal]
    delegate void OnExit();

    // Declare member variables here. Examples:
    // private int a = 2;
    // private string b = "text";

    // Called when the node enters the scene tree for the first time.
    public override void _Ready()
    {
        Visible = false;
    }

    public void _on_Exit_pressed()
    {
        Exit();
    }

    public void _on_Interaction_Mode_OnInteractionModeChanged(InteractionMode.Mode oldMode, InteractionMode.Mode newMode)
    {
        if (oldMode == InteractionMode.Mode.BUILD)
        {
            Visible = false;
            return;
        }
        if (newMode == InteractionMode.Mode.BUILD)
        {
            Visible = true;
            return;
        }
    }

    private void Exit()
    {
        EmitSignal(nameof(OnExit));
    }

    public override void _Input(InputEvent @event)
    {
        if (!Visible)
            return;

        if (!(@event is InputEventKey keyEvent))
            return;

        if (keyEvent.Pressed)
            return;

        if ((KeyList)keyEvent.Scancode == KeyList.Escape)
        {
            Exit();
        }
    }
}
